   --     
   --    ()
   -- ************************************
   -- ,   lst
   -- (   )
   ------------------------------------------
   sortIns:: [Int] -> [Int]
   sortIns lst | null lst = lst
               | True     = insert (head lst) 
                                   (sortIns (tail lst))
   ---------------------------------------------------------
   -- ,   x    -
   --   lst   
   ----------------------------------------------------
   insert:: Int -> [Int] -> [Int]
   insert x lst | null lst    = [x] 
                | x<=head lst = x : lst
                | True        = head lst : insert x (tail lst)
   -- ********************************************************
   -- ,   
   -- (    )
   ----------------------------------------------
   iSort:: [Int] -> [Int]
   iSort []    = []
   iSort (a:x) = ins a (iSort x)
       where ins a [] = [a]
             ins a (b:y) | a<=b = a : b : y
                         | True = b : ins a y
   -- ***************************************
   --   :
   -----------------------------------------------------
   test1 =   sortIns [5,4,3,2,1,6]      == [1,2,3,4,5,6]
          && sortIns (reverse [1..300]) == [1..300]
   ------------------------------------------------
   test2 =   insert 5 []                == [5]
          && insert 5 [1,3..12]         == [1,3,5,5,7,9,11]
   --------------------------------------------------------
   test3 =   iSort [4,3,2,5,4,6,7]      == [2,3,4,4,5,6,7]
          && iSort [7,6,5,4,3,2,1]      == [1,2,3,4,5,6,7]
